关于java:java基础

2次阅读

共计 4505 个字符,预计需要花费 12 分钟才能阅读完成。

五个问题,一次解决,字符子串问题总结

查看原文,请点这个链接

我发现在 leetcode 的问题中,至多有 5 个子字符串寻找问题能够用滑动窗口算法解决,因而我在这里总结了这类算法的模版,心愿能够帮忙你。

1)模版

public class Solution {public List<Integer> slidingWindowTemplateByHarryChaoyangHe(String s, String t) {     
        // 依据问题,初始化一个贮存后果的容器
        List<Integer> result = new LinkedList<>();
        if (t.length()> s.length()) return result;    
        // 创立一个 hashmap 来保留指标子串中的字符
        //(K, V) = (Character, Frequence of the Characters)
        //key 是字符,value 是该字符呈现的次数
        Map<Character, Integer> map = new HashMap<>();
        // 将指标子串转为 map 存储
        for(char c : t.toCharArray()){map.put(c, map.getOrDefault(c, 0) + 1);
        }        
        // 保护一个计数器,去查看是否匹配指标字符串
        int counter = map.size();// 必须是 map 的长度,不是字符串的长度是因为可能元素有反复。// 两个点,窗口的左端点和右端点
        int begin = 0, end = 0;       
          // 匹配指标字符串的子字符串的长度
        int len = Integer.MAX_VALUE;    
        // 从源字符串循环
        while (end < s.length()) {char c = s.charAt(end);// 失去右端点处的字符            
            if (map.containsKey(c)) {map.put(c, map.get(c)-1);// 加一或减一
                if (map.get(c) == 0) counter--;// 依据不同的条件批改计数器
            }
            end++;            
            //increase begin pointer to make it invalid/valid again
            // 计数器条件:不同的问题抉择不同的条件
            while (counter == 0) {char tempc = s.charAt(begin);// 留神:抉择字符是在开始端点而不是完结端点
                if (map.containsKey(tempc)) {map.put(tempc, map.get(tempc) + 1);// 加减一
                    if (map.get(tempc) > 0) counter++;// 依据不同的需要批改计数器
                }                
                /* save / update(min/max) the result if find a target*/
                // 如果发现一个指标,保留、更新(最小、最大)后果
                // result collections or result int value                
                begin++;
            }
        }
        return result;
    }
}

2)相干问题

https://leetcode-cn.com/probl…
https://leetcode-cn.com/probl…
https://leetcode-cn.com/probl…
https://leetcode-cn.com/probl…
https://leetcode-cn.com/probl…

3)具体问题如何利用模版

438. 找到字符串中所有字母异位词
https://leetcode-cn.com/probl…

public class Solution {public List<Integer> findAnagrams(String s, String t) {List<Integer> result = new LinkedList<>();
        if(t.length()> s.length()) return result;
        Map<Character, Integer> map = new HashMap<>();
        for(char c : t.toCharArray()){map.put(c, map.getOrDefault(c, 0) + 1);
        }
        int counter = map.size();
        
        int begin = 0, end = 0;
        int head = 0;
        int len = Integer.MAX_VALUE;        
        
        while (end < s.length()) {char c = s.charAt(end);
            if (map.containsKey(c)) {map.put(c, map.get(c) - 1);
                if (map.get(c) == 0) counter--;
            }
            end++;
            //counter 等于 0 意味着,end 之前至多有可能凑出 target 的字母数量
            while (counter == 0) {char tempc = s.charAt(begin);
                if (map.containsKey(tempc)) {map.put(tempc, map.get(tempc) + 1);
                    if(map.get(tempc) > 0){counter++;}
                }
                if (end - begin == t.length()) {result.add(begin);
                }
                begin++;
            }            
        }
        return result;
    }
}

76. 最小笼罩子串

https://leetcode-cn.com/probl…

public class Solution {public String minWindow(String s, String t) {if(t.length()> s.length()) return "";
        Map<Character, Integer> map = new HashMap<>();
        for(char c : t.toCharArray()){map.put(c, map.getOrDefault(c,0) + 1);
        }
        int counter = map.size();
        
        int begin = 0, end = 0;
        int head = 0;
        int len = Integer.MAX_VALUE;
        
        while(end < s.length()){char c = s.charAt(end);
            if(map.containsKey(c) ){map.put(c, map.get(c)-1);
                if(map.get(c) == 0) counter--;
            }
            end++;
            
            while(counter == 0){char tempc = s.charAt(begin);
                if(map.containsKey(tempc)){map.put(tempc, map.get(tempc) + 1);
                    if(map.get(tempc) > 0){counter++;}
                }
                if(end-begin < len){
                    len = end - begin;
                    head = begin;
                }
                begin++;
            }
            
        }
        if(len == Integer.MAX_VALUE) return "";
        return s.substring(head, head+len);
    }
}

3. 无反复字符的最长子串

https://leetcode-cn.com/probl…

public class Solution {public int lengthOfLongestSubstring(String s) {Map<Character, Integer> map = new HashMap<>();
        int begin = 0, end = 0, counter = 0, d = 0;

        while (end < s.length()) {
            // > 0 means repeating character
            //if(map[s.charAt(end++)]-- > 0) counter++;
            char c = s.charAt(end);
            map.put(c, map.getOrDefault(c, 0) + 1);
            if(map.get(c) > 1) counter++;
            end++;
            
            while (counter > 0) {//if (map[s.charAt(begin++)]-- > 1) counter--;
                char charTemp = s.charAt(begin);
                if (map.get(charTemp) > 1) counter--;
                map.put(charTemp, map.get(charTemp)-1);
                begin++;
            }
            d = Math.max(d, end - begin);
        }
        return d;
    }
}

30. 串联所有单词的子串

https://leetcode-cn.com/probl…

public class Solution {public List<Integer> findSubstring(String S, String[] L) {List<Integer> res = new LinkedList<>();
        if (L.length == 0 || S.length() < L.length * L[0].length())   return res;
        int N = S.length();
        int M = L.length; // *** length
        int wl = L[0].length();
        Map<String, Integer> map = new HashMap<>(), curMap = new HashMap<>();
        for (String s : L) {if (map.containsKey(s))   map.put(s, map.get(s) + 1);
            else                      map.put(s, 1);
        }
        String str = null, tmp = null;
        for (int i = 0; i < wl; i++) {
            int count = 0;  // remark: reset count 
            int start = i;
            for (int r = i; r + wl <= N; r += wl) {str = S.substring(r, r + wl);
                if (map.containsKey(str)) {if (curMap.containsKey(str))   curMap.put(str, curMap.get(str) + 1);
                    else                           curMap.put(str, 1);
                    
                    if (curMap.get(str) <= map.get(str))    count++;
                    while (curMap.get(str) > map.get(str)) {tmp = S.substring(start, start + wl);
                        curMap.put(tmp, curMap.get(tmp) - 1);
                        start += wl;
                        
                        //the same as https://leetcode.com/problems/longest-substring-without-repeating-characters/
                        if (curMap.get(tmp) < map.get(tmp)) count--;
                        
                    }
                    if (count == M) {res.add(start);
                        tmp = S.substring(start, start + wl);
                        curMap.put(tmp, curMap.get(tmp) - 1);
                        start += wl;
                        count--;
                    }
                }else {curMap.clear();
                    count = 0;
                    start = r + wl;//not contain, so move the start
                }
            }
            curMap.clear();}
        return res;
    }
}
正文完
 0